/*
 * wlanmodel/nodemanager.h
 *
 * Copyright (C) 2008-2009 Reto Gantenbein
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __NODEMANAGER_H__
#define __NODEMANAGER_H__

#include <omnetpp.h>
#include <platdep/sockets.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <Ieee802Ctrl_m.h>
#include <Ieee80211Mac.h>
#include <MACAddress.h>
#include "PMTypes.h"
#include "MsgHandler.h"

/** Class manageing the participating wireless nodes */
class NodeManager : public cSimpleModule
{
    public:
        NodeManager();
        ~NodeManager();

        void addNode(registrationMsg *regMsg);
        void removeNode(cModule *host);
        cModule* isRegistered(const host_id *hostId);

    private:
        void handleParameterChange(const char *parname);
};

#endif // __NODEMANAGER_H__
